import * as t from "@babel/types"
import { assert, ensure } from "@samual/lib/assert"
import * as Path from "path"
const babelPluginHere = () => ({
	name: "babel-plugin-here",
	visitor: {
		Program(path) {
			if (!path.scope.hasGlobal("HERE")) return
			const [variableDeclarationPath] = path.unshiftContainer(
				"body",
				t.variableDeclaration("let", [t.variableDeclarator(t.identifier("HERE"))])
			)
			path.scope.crawl()
			assert(this.file.opts.filename, "src/index.ts:19:36")
			const questionMarkIndex = this.file.opts.filename.indexOf("?"),
				filePath = Path.relative(
					".",
					questionMarkIndex > 0 ?
						this.file.opts.filename.slice(0, questionMarkIndex)
					:	this.file.opts.filename
				)
			for (const referencePath of ensure(path.scope.getBinding("HERE"), "src/index.ts:27:70").referencePaths) {
				assert(referencePath.node.loc, "src/index.ts:28:36")
				const line = referencePath.node.loc.start.line,
					column = referencePath.node.loc.start.column + 1
				if ("TemplateLiteral" != referencePath.parent.type) {
					referencePath.replaceWith(t.stringLiteral(`${filePath}:${line}:${column}`))
					continue
				}
				const { parent, node } = referencePath,
					index = parent.expressions.indexOf(node),
					quasi = ensure(parent.quasis[index], "src/index.ts:39:48"),
					nextQuasi = ensure(parent.quasis[index + 1], "src/index.ts:40:56")
				parent.expressions.splice(index, 1)
				delete quasi.value.cooked
				quasi.value.raw = `${quasi.value.raw}${filePath}:${line}:${column}${nextQuasi.value.raw}`
				quasi.tail = nextQuasi.tail
				parent.quasis.splice(index + 1, 1)
			}
			variableDeclarationPath.remove()
		}
	}
})
export { babelPluginHere, babelPluginHere as default, babelPluginHere as here }
